<%
'***************************************************************************
' Validation Functions
' advanced form Handling Version 4.00
' March 11, 2008
' isvalidemail (emaladdress)
' isvalidcreditcard
' isvalidalphanumeric
' isvalidalpha
' isvalidnumeric 
' IsSimplename
' place hidden fields in form in form
' val_fieldname value="numeric"
'************************************************************************
sub valididate (fieldname,fieldvalue,fieldcaption, valtype,msg, rc)
dim othervalues
dim temptype
othervalues=""
temptype=lcase(valtype)
msg=""
rc=0
select case temptype
   case "email"
       rc=isvalidemail(fieldvalue)
       if rc=4  then
           createvalidatemsg fieldname, fieldvalue, fieldcaption, readlang("langinvalidemailaddress"), msg
       end if    
   case "numeric"
        rc=isvalidnumeric(fieldvalue)
       if rc=4  then
           createvalidatemsg fieldname, fieldvalue, fieldcaption, readlang("langinvalidnumeric"), msg
       end if    
   case "alpahnumeric"
       rc=isvalidalphanumeric(fieldvalue, othervalues)
      
       if rc=4  then
           createvalidatemsg fieldname, fieldvalue, fieldcaption, readlang("langinvalidalphanumeric"), msg
       end if    
   case "alpha"
       rc=isvalidalpha(fieldvalue, othervalues)
       
       if rc=4  then
           createvalidatemsg fieldname, fieldvalue, fieldcaption, readlang("langinvalidalpha"), msg
       end if    
   case "creditcard"
       rc=isvalidcreditcard(fieldvalue)
       if rc>0  then
           createvalidatemsg fieldname, fieldvalue, fieldcaption, readlang("langinvalidcreditcard"), msg
       end if
    case "date"
       rc=isvaliddate(fieldvalue)
       if rc=4  then
           createvalidatemsg fieldname, fieldvalue, fieldcaption, readlang("langinvaliddate"), msg
       end if    
    
   case else
       msg="Unknown validation for field " & fieldcaption & "(" & fieldname & ")"  & " " & valtype        
end select   
end sub

sub  createvalidatemsg (fieldname, fieldvalue, fieldcaption, errormsg, msg)
msg=fieldcaption & " (" & fieldvalue & ")" & " " & errormsg
end sub

'********************************************************************
' basic email check
'*******************************************************************
function isValidEmail(sEmail)
dim returnVal
' very simple email validation function.
	returnVal = 4
	if not isEmpty(sEmail) then
		if instr(sEmail, "@") > 0 and instr(sEmail, ".") > 0 then
			returnVal = 0
		end if
	end if
	isValidEmail = returnVal
end function
' Validation Functions
'********************************************************************
' basic email check
'*******************************************************************
function isValidEmail(sEmail)
dim returnVal
' very simple email validation function.
	returnVal = 4
	if not isEmpty(sEmail) then
		if instr(sEmail, "@") > 0 and instr(sEmail, ".") > 0 then
			returnVal = 0
		end if
	end if
	isValidEmail = returnVal
end function

'**********************************************************************
' determines if alphabetic or numeric
'***********************************************************************
Function isvalidAlphaNumeric(strValue, strOtherCharacters) 
dim cclen, pos, char, tempvalue, rc
rc=0
cclen=len(strValue)
tempvalue=lcase(strValue)
For pos = 1 To cclen
' Parse a digit from a specified position in the number
   char = Mid(tempvalue, pos, 1)
   If char<>"" then
     If not isnumeric(char) then 
        If char<"a" or char >"z" then
          rc=4
          exit for
        end if  
     end if
   end if   
next
isvalidAlphaNumeric = rc 
End Function 

'**********************************************************************
' determines if alphabetic
'***********************************************************************
Function isvalidAlpha(strValue, strOtherCharacters) 
dim cclen, pos, char, tempvalue, rc
rc=0
cclen=len(strValue)
tempvalue=lcase(strValue)
For pos = 1 To cclen
' Parse a digit from a specified position in the number
   char = Mid(tempvalue, pos, 1)
   If char<>"" then
     If char<"a" or char >"z" then
      rc=4
      exit for
     end if
   end if   
next
isvalidAlpha = rc 
End Function 
'**********************************************************************
' determines if date format. Use ASP check.
'***********************************************************************
Function isvaliddate(strValue) 
If isdate(strvalue) then
   isvaliddate=0
else
   isvaliddate=4
end if
end function
'*************************************************************************
' Test for valid numeric
'**********************************************************************
Function isValidNumeric (sfieldvalue)
dim returnval
if isnumeric(sfieldvalue) then 
   returnval=0
else
  returnval=4
end if   
isvalidnumeric = returnVal
end function

'*************************************************************************
' Test for valid credit card
' multiple checks are done
' first find credit card typr based on first 4 digits
' then make sure it is numeric
' then test length
' then test mod 10
'**********************************************************************
function Isvalidcreditcard (sfieldvalue)
dim ccnumber, cclength, ccvalidlength, cctype, rc, mod10test
ccnumber = StripnonNumericvalues(sfieldvalue)   ' get only numeric portion
If ccnumber="" then
   rc=20                                       ' non numeric characters
   isvalidcreditcard=rc
   exit function
end if     
cclength=len(ccnumber)                         ' card length
CreditCardtype ccnumber, cctype, ccvalidlength
if ccvalidlength= 0 then
    rc=4
else
   if (ccLength <> ccvalidlength) then
      rc=8
   else
     
      mod10test=Mod10validation(ccnumber) 
      If mod10test=false then
         rc=16
      end if 
  end if
end if      
isvalidcreditcard=rc      
end function
'*****************************************************************
' do some mathematics to see if it is a valid number
'*****************************************************************
Function Mod10Validation(ccnumber)
dim pos, cclen, digit, multiplier, lnsum, total
total=0
cclen=len(ccnumber)
For pos = 1 To cclen
' Parse a digit from a specified position in the number
   Digit=mid(ccnumber,len(ccnumber)-pos+1,1)
   If pos mod 2=0 then
       lnSum=2*cint(Digit)
       Total= Total + (lnsum mod 10)
       if lnSum>9 THEN
          Total=Total+1
       end if 
    else
       Total=Total+ cint(Digit)
    end if
Next 
'Divide by 10, if there is no remainder then the credit card number is valid.
Mod10validation = ((Total Mod 10) = 0)
End Function 

         
'**************************************************************************
' different card compnaies have been assigned
' different ranges. These are subjecto to chnage and this
' may need to me modified in future
'*************************************************************************
Sub Creditcardtype (ccnumber, cctype, ccvalidlength)
dim leftnumber, cclength
ccvalidlength=0
cclength=len(ccnumber)                         ' card length
leftNumber = left(ccNumber, 4)           ' left 4 digits
if (leftnumber >= 3000 and leftnumber <= 3059)  then
        cctype="Diners"
        ccvalidlength = 14
        exit sub
end if
if (leftnumber >= 3600 and leftnumber <= 3699) then
        cctype= "Diners"
        ccvalidlength = 14
        exit sub
end if               
if (leftnumber >= 3800 and leftnumber <= 3889) then 
      cctype= "Diners"
      ccvalidlength = 14
      exit sub
end if 
if (leftnumber >= 3400 and leftnumber <= 3499) then
        cctype = "Amex"
        ccvalidlength = 15
        exit sub
end if           
if (leftnumber >= 3700 and leftnumber <= 3799) then
        cctype = "Amex"
        ccvalidlength = 15
        exit sub
end if        
if (leftnumber >= 3528 and leftnumber <= 3589) then
        cctype = "JCB"
        ccvalidlength = 16
        exit sub
end if        
if (leftnumber >= 3890 and leftnumber <= 3899)  then
        cctype = "Carte Blache"
        ccvalidlength = 14
        exit sub
end if        
If (leftnumber >= 4000 and leftnumber <= 4999) then
        cctype = "Visa"
        ccvalidlength = 16
        if (cclength > 14) then
            ccvalidlength = 16
        else    
           if (cclength < 14) then
              ccvalidlength = 13
           end if
        end if      
end if        
if (leftnumber >= 5100 and leftnumber <= 5599) then 
        cctype = "MasterCard"
        ccvalidlength = 16
        exit sub
end if
if (leftnumber = 5610) then 
        cctype= "BankCard"
        ccvalidlength = 16
        exit sub
end if        
if (leftnumber = 6011)  then 
      cctype = "Discover"
      ccvalidlength = 16
      exit sub
end if      
end sub
'*******************************************************************
' remove blnaks and dash. all else is invalid
'*******************************************************************
function StripNonnumericValues (ccnumber)
dim pos, strchar, newnumber
newnumber=""
For Pos = 1 To Len(ccnumber)
  strchar = Mid(ccnumber, pos, 1)
  If IsNumeric(strChar) Then 
    newnumber=newnumber & strchar
  else
     If strchar="-" or strchar=" " then
     else
         stripNonNumericValues=""
        exit function
     end if
  end if      
Next 
stripNonNumericValues=newnumber
end function

'*******************************************************************
' remove blnaks and dash. all else is invalid
'*******************************************************************
function IsSimpleName (strvalue)
dim rc
rc=isvalidAlphaNumeric(strValue, "_") 
If rc=0 then
   Issimplename=true
else
   IsSimpleName=false
end if
end function

%>