<%
const config_defaultfilename="config_forms.asp"  
'const config_defaultfilename=""
'*************************************************************************************
' Version 4.00
' Copyright: HK Programming
' configuration can be in form fields, constants, in database
' in a set of constants
' Configuration values control how Advanced Form Handler works
' configuration is read into an array so it can be referenced in other parts of tyhe
' program. Configuration can be:
' 1. Hidden form fields
' 2. Text file
' 3. Mixture of the above
' First initializxe Config by using
' ConfigInit
'
' Reference configuration values with
' abc=readconfig("config_emailaddress")
' March 10, 2008 
'
'************************************************************************************
'
Sub ConfigurationInit
configcount=0
Configsetnames                     ' get config names into confignames array
Configformfields                   ' get values from form
configreadconfigfile               ' get values from configfile
configgetdefaults                  ' get any costants
configgetdatabase                  ' get any from database 
configsavesession                  ' save values in session variables
DebugdisplayConfig                 ' display configvalues
end sub
'************************************************************************
' store config names into config names
'***********************************************************************
Sub Configsetnames 
redim confignames(200)
redim configvalues(200)
addconfigname "config_emailaddress" 
addconfigname "config_emailname"
addconfigname "config_emailsubject"
addconfigname "config_emailsystem"
addconfigname "config_emaildriver"
addconfigname "config_emailtemplate"
addconfigname "config_emailresponder"
addconfigname "config_emailresponderfield" 
addconfigname "config_emailfromresponder" 
addconfigname "config_emailrespondertemplate" 
addconfigname "config_completionurl" 
addconfigname "config_completionlink"
addconfigname "config_completiontext"
addconfigname "config_completionformat"
addconfigname "config_completionformattemplate"
addconfigname "config_fieldorder"
addconfigname "config_fieldrequired"
addconfigname "config_fieldexclude"
addconfigname "config_configfile"
addconfigname "config_securityreferer"
addconfigname "config_databasename"
addconfigname "config_databasetype"
addconfigname "config_databaselocation" 
addconfigname "config_databaseuserid"              
addconfigname "config_databasepassword"          
addconfigname "config_databaseserver"
addconfigname "config_databasedriver"
addconfigname "config_databasetable"
addconfigname "config_databaseupdate"
addconfigname "config_databaseaddfields"
addconfigname "config_language"
addconfigname "config_purchasereference"
addconfigname "config_tracemail"
addconfigname "config_trace" 
addconfigname "config_emailattachment" 
addconfigname "config_formname" 
addconfigname "config_multiform"
addconfigname "config_afhform"
'searching
addconfigname "config_displaytable"
addconfigname "config_displaytemplate"
addconfigname "config_displayfields"
addconfigname "config_displaysortfield"
addconfigname "config_displayrecords"
addconfigname "config_displaymatchtype"
addconfigname "config_displayheader"
addconfigname "config_displaytrailer"
addconfigname "config_displaylinkfield"
addconfigname "config_matchfields"
addconfigname "config_captcha"
addconfigname "config_privatesession"
addconfigname "config_privatecookie"
addconfigname "config_privatefields"
addconfigname "config_privatevalues"
addconfigname "config_timedifference"
end sub
'*******************************************************************
' add names to confignames array
'******************************************************************
SUB addconfigname(iname)
confignames(configcount)=lcase(iname)
configcount=configcount+1
end sub
'**********************************************************************************
' get values from form
'*********************************************************************************
sub Configformfields 
dim fieldname, fieldsvalue, i
for i =0 to configcount-1
  fieldname=confignames(i)
  fieldvalue=request.form(fieldname)
 ' debugwrite fieldname & "=" & fieldvalue
  configvalues(i)=fieldvalue
next
ConfigGetvalidationFields              ' read all validation values
end sub
'*********************************************************************************
' see if there is  a default file name  afhdefaults.asp
'********************************************************************************
sub  ConfigGetDefaults
dim filename
filename=config_defaultfilename
If filename="" then exit sub
ConfigProcessfile filename
end sub
'******************************************************************************
' config_configfile=filename
' if file name is specified, read the file, parse it and store values in config
' array
'//* are comments for config table
'******************************************************************************
sub configreadconfigfile
dim filename
filename=readconfig("config_configfile")  
if filename="" then exit sub
configprocessfile filename
end sub
'********************************************************************************
' read records in a configuration file
'********************************************************************************
sub configprocessfile (filename)
dim records(500), recordcount, rc, fieldname, fieldvalue
DIM I, record, currentvalue, j
ReadSystemFile filename, rc, records, recordcount   ' read whole file into memory
If rc>0 then                                        ' if ther was an error get out
   exit sub
end if   
for i = 0 to recordcount-1
   record=records(i)
   CheckRecordComment Record, rc
   If rc=0  then
       configparserecord record, fieldname, fieldvalue, rc
       if rc=0 then 
         j=findconfig(fieldname, currentvalue)               ' see if there is a form value
         if j=-1 then
            addconfigvalue  fieldname, fieldvalue             ' not found in confignames table, add it
         else
            if currentvalue="" then                           ' does it already have a value
               configvalues(j)=fieldvalue                     ' update null value  
            end if                                            'leave current value    
         end if
       end if
    end if        
next
end sub
'***************************************************************************
'add an entry to confignames and config values
'***************************************************************************
sub addconfigvalue (fieldname, fieldvalue)
configvalues(configcount)=fieldvalue              ' save vlaue
confignames(configcount)=lcase(fieldname)         ' save lower case config name
configcount=configcount+1                         ' count number of configs
end sub


'***********************************************************************************
' record in form
' abc="def"
'*********************************************************************************** 
Sub  Configparserecord (record, fieldname, fieldvalue, rc)
dim pos, length
pos=instr(record,"=")
if pos=0 then
   rc=4
   exit sub
end if
length=len(record)
fieldname=left(record, pos-1)
length=length-pos
fieldvalue=right(record, length)
fieldvalue=replace(fieldvalue,"""","")
rc=0
'debugwrite "Fieldname=" & fieldname & " Fieldvalue=" & fieldvalue 
end sub
'*************************************************************************************
' make sure config values are there
'************************************************************************************
Sub ActionvalidateConfigurationvalues
ActionValidateConfig  "config_emailaddress",config_emailaddress
Actionvalidateconfig  "config_emailname", config_emailname
ActionValidateconfig  "config_emailsubject", config_emailsubject
ActionValidateconfig  "config_emailsystem",config_emailsystem
Actionvalidateconfig  "config_emaildriver",config_emaildriver
If errormsg="" then
    config_securityreferer=requesttext("config_securityreferer")
    If config_securityreferer<>"" then
        ActionvalidateReferer  config_securityreferer
    end if
end if        
end sub

'****************************************************************************
' certain config values are required
' they count be in the form itself in in a configuration file
'****************************************************************************
Sub ActionValidateConfig (configname, configvalue)
configvalue=request(configname)
if configvalue="" then
    if configcount>0 then 
       ActionFindConfig configname, configvalue, confignames, configvalues, configcount
    end if
end if
if configvalue="" then 
      adderrormsg configname & " " & " " & langrequired
end if      
end sub

'*********************************************************************************
' search form fields array to find form field name
'**********************************************************************************
function  readconfig (fieldname)
dim i, lcfieldname
fieldvalue=""
if configcount="" or configcount=0 then
   readconfig=""
   exit function
end if   
lcfieldname=lcase(fieldname)
for i = 0 to configcount-1
    if lcfieldname=confignames(i) then
       fieldvalue=configvalues(i)
       readconfig=fieldvalue
       exit function
    end if
next
readconfig=fieldvalue
end function

'*********************************************************************************
' search form fields array to find form field name
' need to know if config already has nmae in confignames
' returns entry in confignames table (i) or -1 if not found
'**********************************************************************************
function  Findconfig (fieldname, fieldvalue)
dim i, lcfieldname
fieldvalue=""
lcfieldname=lcase(fieldname)
for i = 0 to configcount-1
    if lcfieldname=confignames(i) then
       fieldvalue=configvalues(i)
       findconfig=i
       exit function
    end if
next
findconfig=-1
end function

sub DebugdisplayConfig 
dim i
if lcase(readconfig("config_trace"))<>"yes" then exit sub
exit sub
'*********************************************************************************
' some values are actually constants in ASP.
' These include database locations etc
'*********************************************************************************
if configcount=0 then
   response.write  "no configuration<br>"
   exit sub
end if   
for i = 0 to configcount-1
    response.write confignames(i) & "=" & """" & configvalues(i) & """" & "<br>"
next    
end sub
sub configgetdatabase
end sub
'****************************************************************************************
' allow comments in file
' quote(') or //
'***************************************************************************************
sub CheckRecordComment (record, rc)
dim testfield
rc=0
testfield=left(record,1)
if testfield="'" then
   rc=4
   exit sub
end if
testfield=left(record,2)
if testfield="//" then
   rc=4
   exit sub
end if      
end sub
sub configsavesession 
writesessarray "confignames",confignames
writesessarray  "configvalues",configvalues
writesess "configcount",configcount
end sub
'*************************************************************************************
' configuration can be in form fields, constants, in database
' in a set of constants
' Version 1.0  October 1, 2005
'************************************************************************************
'
Sub Languageinit
langcount=readconfig("langcount")
langcount=""
if langcount="" then
   langcount=0
   langreadlanguagefile            ' get values from configfile
   writesessarray "languagenames",langnames
   writesessarray "langvalues",langvalues
   writesess  "langcount",langcount
else
   langnames=readsessarray("langnames")
   langvalues=readsessarray("langvalues")
   langcount=readsess("langcount")
end if
'Debugdisplaylang                ' display configvalues
end sub

'******************************************************************************
' config_filename=filename
' if file name is specified, read the file, parse it and store values in config
' array
'//* are comments for config table
'******************************************************************************
sub langreadlanguagefile
dim filename, language
language=readconfig("config_language")
'debugwrite "config=" & readconfig("config_language")
if language="" then
    language="English"
end if
filename="afhlanguage_" & language & ".asp"
'debugwrite "filename=" & filename
filename=lcase(filename)
langprocessfile filename
end sub
'********************************************************************************
' read records in a configuration file
'********************************************************************************
sub langprocessfile (filename)
dim records(500), recordcount, rc, fieldname, fieldvalue
DIM I, record, currentvalue, j
ReadSystemFile filename, rc, records, recordcount   ' read whole file into memory
If rc>0 then                                        ' if ther was an error get out
   exit sub
end if   
for i = 0 to recordcount-1
   record=records(i)
   langCheckRecordComment Record, rc
   If rc=0  then
       langparserecord record, fieldname, fieldvalue, rc
       addlangvalue  fieldname, fieldvalue             ' not found in confignames table, add it
   end if
next
end sub
'***************************************************************************
'add an entry to confignames and config values
'***************************************************************************
sub addlangvalue (fieldname, fieldvalue)
langvalues(langcount)=fieldvalue              ' save vlaue
langnames(langcount)=trim(lcase(fieldname))         ' save lower case config name
langcount=langcount+1                         ' count number of configs
end sub

'*****************************************************************************
' reads an array into memory
'****************************************************************************
sub langReadSystemFile (filename, rc, filearray, readcount)
on error resume next
'debugwrite "doing filename=" & filename
if filename="" then
   rc=4
   exit sub
end if   
dim realfile,  fsobj,openfileobj, record
readcount=0
realfile=server.mappath(filename)
set fsObj = Server.CreateObject("Scripting.FileSystemObject")
set openfileObj= fsObj.OpenTextFile(realfile, 1, False)
If err.number > 0 then
      rc=4
      fsObj.close
      ser openfile=nothing
      set fsObj=nothing
      exit sub
end if
do while not openfileObj.AtEndofStream 
   record = openfileObj.readline
   filearray(readcount)=record
   readcount=readcount+1
Loop
openfileobj.close
set openfileobj = nothing
set fsObj = nothing
End Sub

'***********************************************************************************
' record in form
' abc="def"
'*********************************************************************************** 
Sub  langparserecord (record, fieldname, fieldvalue, rc)
dim pos, length
pos=instr(record,"=")
if pos=0 then
   rc=4
   exit sub
end if
length=len(record)
fieldname=left(record, pos-1)
length=length-pos
fieldvalue=right(record, length)
fieldvalue=replace(fieldvalue,"""","")
rc=0
'debugwrite "Fieldname=" & fieldname & " Fieldvalue=" & fieldvalue 
end sub

'*********************************************************************************
' search form fields array to find form field name
'**********************************************************************************
function  readlang (fieldname)
dim i, lcfieldname, fieldvalue
fieldvalue=""
lcfieldname=lcase(fieldname)
for i = 0 to langcount-1
    if lcfieldname=langnames(i) then
       fieldvalue=langvalues(i)
       readlang=fieldvalue
       exit function
    end if
next
readlang=fieldname
end function

sub Debugdisplaylang 
dim i
'*********************************************************************************
' some values are actually constants in ASP.
' These include database locations etc
'*********************************************************************************
if langcount=0 then
   response.write  "no language<br>"
   exit sub
end if   
for i = 0 to langcount-1
    response.write langnames(i) & "=" & """" & langvalues(i) & """" & "<br>"
next    
end sub

'****************************************************************************************
' allow comments in file
' quote(') or //
'***************************************************************************************
sub langCheckRecordComment (record, rc)
dim testfield
rc=0
testfield=left(record,1)
if testfield="'" then
   rc=4
   exit sub
end if
testfield=left(record,2)
if testfield="//" then
   rc=4
   exit sub
end if      
end sub


'*************************************************************
' Operating System functions such as session and application variables
' Response redirect
' response.write
' HK Programming
' Jan 1, 2005
'********************************************************************
' writesess  save  avalue into session variable
'*********************************************************************
Sub writesess (field, value)
Session(field)=value
end sub
'
'********************************************************************
' writesessarray  saves and array into session variable
'*********************************************************************
Sub writesessArray (field, value)
Session(field)=value
end sub
'
'********************************************************************
' readsess  retrieves a value from a session variable
'*********************************************************************
Function readsess (field)
dim value
value=Session(field)
readsess=value
End Function
'
'********************************************************************
' readsessArray  retrieves a array value from a session variable
'*********************************************************************
Function readsessArray (field)
dim value
value=Session(field)
readsessArray=value
End Function
Sub ConfigGetvalidationfields
'************************************************************************
' for each form field with validation prefix
' val_xxxxxx  where xxx is fieldname
'************************************************************************
dim fieldname, fieldvalue, prefixlength, field, prefix
prefixlength=len(validationprefix)
for each field in request.form
    prefix=left(field,prefixlength)
    prefix=lcase(prefix)
    if prefix=validationprefix then
       fieldvalue=request.form(field)
       addconfigvalue  field, fieldvalue   ' not found in confignames table
    end if   
next
end sub

'*****************************************************************************
' read html from table afhhtml
'****************************************************************************
sub ReadSystemFileinTable (filename, rc, filearray, readcount)
dim conn, prefix, rs, sql, tempfile, table
'on error goto 0
table="afhhtml"
opendatabase conn
prefix=left(filename,1)
if lcase(prefix)="_" then
   tempfile=right(filename,len(filename)-1)
else
   tempfile=filename
end if   
tempfile=filtertext(tempfile)   
sql="select * from "& table & "  where filename='" & tempfile & "'"
readcount=0
set rs=conn.execute(sql)
do while not rs.eof
    filearray(readcount)=rs("filedata")
    readcount=readcount+1
    rs.movenext
loop    
closerecordset rs
closerecordset conn
if readcount=0 then
    rc=4
else
    rc=0
end if
end sub
'****************************************************************************************
'  Read entire template into memory first
' 
'***************************************************************************************
sub ReadSystemFile (filename, rc, filearray, readcount)
dim realfile,  fsobj,openfileobj, record, tablefile
 on error resume next
 rc=0
if filename="" then
   rc=4
   exit sub
end if   
tablefile=left(filename,1)
If lcase(tablefile)="_" then
   ReadSystemFileinTable filename, rc, filearray, readcount
   exit sub
end if   
readcount=0
realfile=server.mappath(filename)
set fsObj = Server.CreateObject("Scripting.FileSystemObject")
set openfileObj= fsObj.OpenTextFile(realfile, 1, False)
If err.number > 0 then
      rc=4
      fsObj.close
      set openfile=nothing
      set fsObj=nothing
      exit sub
end if
do while not openfileObj.AtEndofStream 
   record = openfileObj.readline
   filearray(readcount)=record
   readcount=readcount+1
Loop
openfileobj.close
set openfileobj = nothing
set fsObj = nothing
End Sub

%>