<%
const templeftdelimiter="["
const temprightdelimiter="]"
const tempignoreline="//*"
const tempignorelinefield="//F"
dim tempdbfields(255), tempdbvalues(255), tempdbtypes(255), tempdbcount
Dim tarray(1000), tarraycount
'***************************************************************************
' Copyright: HK Programming. All rights reserved
' Advanced Form Handkling Version 4.00
' Template handling merges a template file with either database fields
' or fields found in another array. Templates are plain text.
' They cannot have any ASP logic in them. Comments can be included in the form
' //* comment
' Lines can be ignored during substitution usig
' //F as first three characters
' These are [        ]
' special controls are
'  [SPECIAL date]
'  [SPECIAL time]
'  [SERVER  servervariable name]
' for fields they can be formmated using certain controls
'  [formatnumber xxx]
'  [formatdate xxx]
'  [formattime xxx]
'  [formatcurrency xxx]
'  March 10, 2008
'  ****************************************************************************
Function WriteTemplateWithRecordset (rs, template, errormsg)
Dim i, rc
Readsystemfile  template, rc, tarray, tarraycount
if rc>0 then 
    errormsg=errormsg & "Unable to read " & template
    exit function
end if
TemplateReaddatabase rs, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
TemplateSubstitute tarray, tarraycount, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
for i = 0 to tarraycount-1
    response.write tarray(i)  & vbcrlf
next    
end function

Function TemplateWithRecordset (rs, template, errormsg)
Readsystemfile  template, rc, tarray, tarraycount
if rc>0 then 
    errormsg=errormsg & "Unable to read " & template
end if
TemplateReaddatabase rs, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
TemplateSubstitute tarray, tarraycount, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
end function
'*********************************************************************
' for evey record in template we do subsitution
' records starting with ***  are skipped
' Record starting with  **!  are skipped if no fields are subsituted
'   
'*********************************************************************
Sub TemplateSubstitute  (tarray, tcount, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount)
dim i, record, ignore, outrecord
dim outarray(1000), outcount
outcount=0
for i = 0 to tcount-1
  record=tarray(i)
  templateReplace record, outrecord, ignore,  tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
  If ignore=false then
     outarray(outcount)=outrecord
     outcount=outcount+1
  end if
next
' put back all records that were substituted
for i = 0 to outcount-1
   tarray(i)=outarray(i)
next   
tcount=outcount
end sub
'
'*******************************************************************************
' locate left delimiter, if found, find right delimiter, if found
' substitute database field
' parse record for delimiters
' do substitution
' continue until no more are foud
'*******************************************************************************
Sub TemplateReplace (record, workrecord, ignore, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount)
dim ignorefields                   ' should this line be ignored
dim done                           ' control for loop
dim tokenname                      ' field that we are looking for
dim tokenformat                    ' qualifier such as formatdate
dim tokentype                      ' formatcurrency. formatdate time
dim tokens(5)                      ' token array
dim tokencount                     ' count in token array
dim tokenfound                     ' truer means at least one substition has taken place
dim tokenvalue                     ' value to replace token
Dim token                          ' item between [...]
Dim Newrecord                      ' substitured record
Dim found                          ' substitution has taken place
Dim pos,endpos,length,rc              ' parsing work areas
pos = 1
done=False
ignore=false
workrecord = record
tokenfound = False        ' used to determine if record is ouput if starts with a $
ignorefields = Left(workrecord, len(tempignoreline)) 
if ignorefields=tempignoreline then
   ignore=true                     ' this line starts with ignore characters
   exit sub
end if
'debugwrite "parsing " & record  
Do While done=false
   pos = InStr(pos, workrecord, templeftdelimiter)   ' does this line have a subsitute
   If pos > 0 Then                               ' yes 
       endpos = InStr(pos, workrecord, temprightdelimiter)      ' does it have right delimiter
       If endpos=0 then          
           Displayerrors "Template error. Unable to locate " & templeftdelimiter & " in record " & record
           done=true                             ' finished parsing
       else  
        length = endpos - pos + 1
        tokenformat=""
        token = Mid(workrecord, pos, length)
        tokenName = Mid(token, 2, length - 2)
        convertToArray  tokenname, tokens, tokencount, " "
        if tokencount> 1 then
          tokenName=tokens(1)           
          tokenformat=ucase(tokens(0))      ' formatcurrency, formatnumber, SPECIAL
        end if 
        'debugwrite "tokename=" & tokenname & " takenformat=" & tokenformat
        GetTokenvalue tokenName, tokenformat, tokenvalue, rc, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
        Newrecord = Find_Replace(workrecord, token, tokenvalue, 0)
        If tokenvalue <> "" Then
           tokenfound = True               
        End If
        workrecord = Newrecord
       end if
    Else
       done=true
    End If
Loop
'debugwrite "workrecord=" & workrecord
ignorefields = Left(workrecord, len(tempignorelinefield)) 
if ignorefields=tempignorelinefield then           
  If tokenfound=false   then 
       ignore=true                  ' ignore linme if no substitions
       workrecord=""
       Exit Sub
  else 
  ' stip of //F and return only data portion of the line
   length = Len(workrecord) - len(tempignorelinefield)
   Newrecord = Mid(workrecord, len(tempignorelinefield)+1, length)
  workrecord = Newrecord
 end if
end if  
End Sub

'
'************************************************************************************
' Standard Find replace logic from most VP manuals
'************************************************************************************
Function Find_Replace(srchString, FndString, InsertString,   strend ) 
  Dim i, LastChar, Next_Pos 
  Dim CurrentPos, LastPos
  Dim tempstring 

  If strend > 0 Then
    LastChar = strend
  Else
    LastChar = Len(srchString)
  End If
  tempstring = srchString
  Next_Pos = 0
  Next_Pos = InStr(Next_Pos + 1, tempstring, FndString)
  Do Until (Next_Pos = 0) Or (Next_Pos > LastChar)
    tempstring = Left(tempstring, Next_Pos - 1) & InsertString & Right(tempstring, (Len(tempstring) - Len(FndString) - (Next_Pos - 1)))
    LastChar = LastChar - Len(FndString) + Len(InsertString)
    Next_Pos = 0
    Next_Pos = InStr(Next_Pos + 1, tempstring, FndString)
  Loop
  Find_Replace = tempstring
End Function

'********************************************************************************************
' we have a token such as xxxxx where xxx may be adatabase field
' Need to replace thar with some real value
' keywords are things like SECIAL, SERVERVARS
'****************************************************************
Sub GetTokenvalue (tokenName, tokenformat, tokenvalue, rc, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount)
rc = 0
TemplateProcessKeyword tokenName, tokenformat, tokenvalue, rc
If rc = 0 Then Exit Sub
TemplateFindInDatabase tokenname, tokenvalue ,rc, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
If rc > 0 then
    'TemplateError "Unable to find " & tokenName & " in database"
    if lcase(readconfig("config_trace"))="yes" then
        tokenvalue="??? (" & tokenname & ")"
     else   
       tokenvalue=""
     end if  
    exit sub
end if
Templateformatfield tokenvalue, tokenformat
End Sub
'
'*************************************************************************************
' search array for the same name and if found replace database value with
' value in table
'*************************************************************************************
Sub TemplateFindInDatabase (tokenName, tokenvalue, rc, fieldnames, fieldvalues, fieldtypes, fieldcount)
dim i, fieldname
fieldname=lcase(tokenName)
for i=0 to fieldcount-1
     'debugwrite "comparing" & fieldname & " with " & fieldnames(i)  & " count=" & fieldcount
       if lcase(fieldname)=lcase(fieldnames(i)) then
          tokenvalue=fieldvalues(i)
           rc=0
          exit sub
     end if
next
rc=4
tokenvalue="" 
end sub
'
'***************************************************************************
' see if any special keywords that need special processing
' tokenformat is really the keyword, tokenname is actually thing do do
'***************************************************************************
Sub TemplateProcessKeyword (tokenName, tokenformat, tokenvalue,  rc)
dim keyword
rc=4
If tokenformat="" then exit sub
keyword=lcase(tokenformat)
'debugwrite "looking for " & tokenformat
select  case keyword
     Case "include"
        TemplateKeyInclude tokenname, tokenformat, tokenvalue, rc
        rc=0
     Case "special"
        TemplateSpecials tokenname, tokenformat, tokenvalue, rc
        rc=0   
     Case "servervars"
        TemplateServervars tokenname, tokenformat, tokenvalue, rc
        rc=0       
end select 
end sub

'***************************************************************************
' see if there is any special formatting
' sucvh as current or date
'**************************************************************************
Sub TemplateFormatField (tokenvalue, tokenformat)
If tokenformat="" then exit sub
dim ltokenformat, decimalpoint
decimalpoint=readconfig("config_decimalpoint")
if decimalpoint="" then
  decimalpoint=2
end if  
ltokenformat=lcase(tokenformat)
 Select Case ltokenformat
	Case "formatcurrency"
              tokenvalue = tokenformatcurrency(tokenvalue,decimalpoint)
        Case "formatnumber"
              tokenvalue = tokenformatnumber(tokenvalue,decimalpoint)
        Case "formatdate"
               tokenvalue = tokenformatdate (tokenvalue,readconfig("config_dateformat"))
        Case "formaturlencode"
               tokenvalue = tokenformaturlencode(tokenvalue)   
        Case "formattime"
             value = tokenformattime(tokenvalue,vbshorttime)
	Case "formatimage"
             tokenvalue = tokenformatimage(tokenvalue)
	End Select
end sub
'***********************************************************************
' format value as currency. uses
' config_decimalpoint, config_currencysymbol
'**********************************************************************
Function tokenformatcurrency(tokenvalue,idecimalpoint)
dim symbol
dim decimalpoint
if idecimalpoint="" then
  decimalpoint=2
else
  decimalpoint=idecimalpoint
end if    
symbol=readconfig("config_CurrencySymbol")
If symbol="" then
   tokenformatcurrency=formatCurrency (tokenvalue, decimalpoint)
else
   tokenformatcurrency=symbol & " " & formatNumber (tokenvalue, decimalpoint)
end if   
end function

'*********************************************************************
' format value as a number. uses config_decimalpoint
'********************************************************************
Function tokenformatnumber(tokenvalue,idecimalpoint)
dim decimalpoint
if idecimalpoint="" then
  decimalpoint=2
else
  decimalpoint=idecimalpoint
end if    
tokenformatnumber=formatNumber (tokenvalue, decimalpoint)
end function
'******************************************************************
' format date . Uses Config_datefornat
'******************************************************************
Function tokenformatdate(tokenvalue,dateformat)
if dateformat="" then 
   tokenformatdate=formatdatetime(tokenvalue,vblongdate)
   exit function
end if
tokenformatdate=formatdatefunc(tokenvalue,dateformat)
   
end function

'******************************************************************
' format time
'******************************************************************
Function tokenformattime(tokenvalue, timeformat)
tokenformattime=formatdatetime(tokenvalue, timeformat)
end function

'*******************************************************************
' format field in URL encode format
'*******************************************************************
Function tokenformaturlencode(tokenvalue)
tokenurlencode=server.urlencode(tokenvalue)
end function


'******************************************************************
' get database fields and types and store into arrays
'******************************************************************
Sub TemplateReaddatabase (RS, fieldnames, fieldvalues, fieldtypes, fieldcount)
Dim counter, fld, fieldname, i
counter=0                         ' current record in fieldnames
fieldcount=RS.fields.count
' memo fields must be gotten first
  For each fld in RS.Fields
         fieldType = fld.type        ' get the type
         fieldname=fld.name           ' get field name
         fieldnames(counter) = lcase(fieldname)  ' turn to lower case
         fieldtypes(counter)=fieldtype
         If Fieldtype="201" then       ' if it is memo then
             fieldvalues(counter)=rs(fieldname)      ' save it
         end if    
         counter=counter+1
  next
' now have all names but only values for memos. now we need values for others  
for i=0 to fieldcount-1
   if fieldtypes(i)<>"201" then
        fieldvalues(i)=rs(i).value
   end if  
   if isnull(fieldvalues(i)) then
          fieldvalues(i)=""
   end if 
next
End Sub
Sub TemplateKeyInclude (tokenvalue)
end sub
'*************************************************************************************
' for each form field, generate template record in form
' fieldname: [fieldname]
'*************************************************************************************
Function TemplateGenerateTemplate (formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount, tarray, tarraycount   )
dim i, record, fieldname, formname, caption
formname=readconfig("config_formname") 
tarraycount=0
for i = 0 to formfieldcount-1
    fieldname=formfieldnames(i)
    caption=readcaption(fieldname, formname)
    record = caption & ":" & " " & templeftdelimiter & fieldname & temprightdelimiter 
    tarray(tarraycount)=record
    tarraycount=tarraycount+1
'    debugwrite "temp=" & record
next     
end function
Function Templateerror (msg)
response.write msg & "<br>"
end function

Function Processcontinue
dim i
Displaypageheader
for i = 0 to tarraycount-1
   debugwrite tarray(i)
next
displaypagetrailer    
end function

'********************************************************************
' reads a file into an array
' then does substitution on that file
' returns array and array count
'************************************************************************
Function ReadTemplateWithRecordset (rs, template, errormsg, tarray, tarraycount)
Dim i, rc
Readsystemfile  template, rc, tarray, tarraycount
if rc>0 then 
    errormsg=errormsg & "Unable to read " & template
    exit function
end if
TemplateReaddatabase rs, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
TemplateSubstitute tarray, tarraycount, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
end function

Function TemplateWithRecordset (rs, template, errormsg)
Readsystemfile  template, rc, tarray, tarraycount
if rc>0 then 
    errormsg=errormsg & "Unable to read " & template
end if
TemplateReaddatabase rs, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
TemplateSubstitute tarray, tarraycount, tempdbfields, tempdbvalues, tempdbtypes, tempdbcount
end function


'***********************************************************************
' Special variables allow you to add date, time to template dynamically
'*********************************************************************
Sub  TemplateSpecials (tokenname, tokenformat, tokenvalue, rc)
tokenname=lcase(tokenname)
rc=4
select case tokenname
    case "date"
       tokenvalue=tokenformatdate (getcurrentdate(),readconfig("config_dateformat"))
       rc=0
    case "time"
        tokenvalue=tokenformattime (getcurrenttime(),vblongtime)
        rc=0
    case else
         debugwrite "Unknown token " & tokenname
end select      
end sub
'*******************************
'***********************************************************************
' Special variables allow you to add date, time to template dynamically
'*********************************************************************
Sub  TemplateSErverVars (tokenname, tokenformat, tokenvalue, rc)
dim servervalue
servervalue=""
on error resume next
servervalue=request.servervariables(tokenname)
tokenvalue=servervalue
end sub
'***************************************************************************************
' prevent hackers from reading files by only allowing
' .txt and .htm files
'*************************************************************************************
Function Validatetemplatename(filename)
dim suffix, newfile
newfile=filename
suffix=right(filename,3)
suffix=lcase(suffix)
if suffix="txt" or  suffix="htm" then
    ValidateTemplatename=newfile
    exit function
end if
suffix=right(filename,4)   
if lcase(suffix)<>"html" then
   newfile=""
end if
ValidateTemplatename=newfile   
 
end function

Function TokenFormatimage (fieldvalue)
dim newvalue
if fieldvalue="" then 
   TokenFormatimage=""
   exit function
end if   
newvalue="<img border='0' src='" & fieldvalue & "'>"
tokenformatimage=newvalue
end function

%>
